#ifndef SWITCHBOARD_H
#define SWITCHBOARD_H

#include <sys/types.h>
#include "blackbox.h"

#define ALCHEMIST_CACHE_DIR "/var/cache/alchemist/"
#define ALCHEMIST_SWITCHBOARD_DIR "/etc/alchemist/switchboard/"


struct AdmBlackBox {
	AdmBlackBoxMethods	*methods;
	void			*data;
	AdmRefStr		*cache_id;
	unsigned int		 cache_depth;
	unsigned int		 refcount;
	uid_t			 cache_uid;
	gid_t			 cache_gid;
	adm_bb_cap_t		 caps;
};

#define ADM_BBCAP_SET_SUP_WRITE(CAP)		((CAP).array[0] |= (1 << 0))
#define ADM_BBCAP_SET_SUP_READ(CAP)		((CAP).array[0] |= (1 << 1))
#define ADM_BBCAP_SET_SUP_LISTSERIAL(CAP)	((CAP).array[0] |= (1 << 2))
#define ADM_BBCAP_SET_SUP_READSERIAL(CAP)	((CAP).array[0] |= (1 << 3))
#define ADM_BBCAP_SET_CACHED(CAP)		((CAP).array[0] |= (1 << 4))

AdmContext *
_adm_cache_readSerial (const char    *cache_id,
		       unsigned int   serial);

void _adm_cache_write (AdmContext    *context,
		       const char    *cache_id,
		       uid_t		uid,
		       gid_t		gid,
		       unsigned int   depth);

int _adm_cache_listSerial   (const char    *cache_id,
			     unsigned int  *array,
			     unsigned int   array_len,
			     unsigned int   top_serial,
			     unsigned int   prefill_count);

int _adm_cache_set_mark (const char   *cache_id,
		       uid_t		uid,
		       gid_t		gid,
			      const char   *mark);

int _adm_cache_clear_mark (const char   *cache_id,
			        const char   *mark);

unsigned int _adm_cache_get_mark (const char   *cache_id,
				       const char   *mark);

#endif/*SWITCHBOARD_H*/
